> For the complete documentation index, see [llms.txt](https://docs.inabit.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.inabit.com/api-reference/introduction-to-graphql/what-is-graphql.md).

# What is GraphQL?

[GraphQL](https://graphql.org/) is a query language for APIs that provides a powerful and flexible way for clients to request exactly the data they need from a server. Unlike traditional REST APIs that return predefined data structures, GraphQL allows you to specify the specific fields you want within a resource, eliminating the need for over-fetching or under-fetching of data. This approach leads to more efficient data transfer and reduces complexity on both the client and server sides.

GraphQL revolutionizes API interactions by letting you request exactly the data you need. Forget fetching everything and sifting through irrelevant details. Write precise queries specifying only the desired fields within a resource, and GraphQL delivers just that. This targeted approach streamlines data exchange, boosts performance, and simplifies development – like ordering a custom pizza, not the whole menu.

The key takeaway for GraphQL can be summarized as **ask for what you need** and **get exactly that .**

For more information about GraphQL visit <https://graphql.org/>


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.inabit.com/api-reference/introduction-to-graphql/what-is-graphql.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
